Added new eject_opts option for greater flexibility.
[rip_dvd/.git] / rip_dvd
diff --git a/rip_dvd b/rip_dvd
index 7158101ea1475b41244ba1c92d4261172e2590ae..8a8c2fa072287fc0371adb4ed29d70a5c0e6e03d 100755 (executable)
--- a/rip_dvd
+++ b/rip_dvd
@@ -3,7 +3,7 @@
 # Author: Alan J. Pippin (apippin@pippins.net)
 # Date: 05/17/2009
 #
-  REV=2.0
+  REV=2.5
 #
 # Description: This script wraps a number of linux utilities to
 # create a recipe for ripping protected DVDs, circumventing 
 # Known Issues/Limitations:
 # - Mirror mode is always done in ISO mode
 #
-# Package Dependencies (apt-get install these for example):
-# lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
-#
-# Specific Executable (program) Dependencies (must be found in $PATH):
-# volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs HandBrakeCLI
-#
-# Optional Dependencies:
-# lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
-#
+# See the README file for information about the dependencies
+# this script has.
 
 ##############################################################################################
 # Global Variables
@@ -38,11 +31,24 @@ typeset dvdpath=""
 typeset aspect=""
 typeset SCALE=""
 typeset CROP=""
-typeset profile="xvidvhq"
+typeset profile="xvidhq"
 typeset extension=""
 typeset mailto=""
 typeset encoder=""
+typeset ripper=""
 typeset default_alang="en"
+typeset track=""
+typeset drc="0.0"
+typeset handbrake_xvid=""
+typeset handbrake_mp4=""
+typeset makemkv=""
+typeset makemkv_disc_id=""
+typeset mkvextract=""
+typeset mkvpropedit=""
+typeset mkvmerge=""
+typeset mp4box=""
+typeset dvdxchap=""
+typeset eject_opts="-T"
 typeset -i default_aid=128
 typeset -i aid_override=-1
 typeset -i force_onepass_mode=0
@@ -58,13 +64,22 @@ typeset -i make_final_dest_comp=0
 typeset -i errors=0
 typeset -i show_usage=0
 typeset -i mirror_mode=0
-typeset -i target_bitrate=2000
+typeset -i target_video_bitrate=2000
+typeset -i target_audio_bitrate=224
 typeset -i target_size=0
 typeset -i audio_2ch=0
-typeset -i audio_6ch=1
+typeset -i audio_6ch=0
 typeset -i invalid_feature_title=0
 typeset -i feature_title_override=0
 typeset -i mplayer_dumpstream_incompatibility=0
+typeset -i lsdvd_incompatibility=0
+typeset -i custom_video_bitrate=0
+typeset -i custom_audio_bitrate=0
+typeset -i custom_audio_2ch=0
+typeset -i custom_audio_6ch=0
+typeset -i minimum_feature_title_length=60
+typeset -i lsdvd_timeout=10
+typeset -i makemkv_copy_largest_title_only=1
 
 ##############################################################################
 # Local Machine Settings:
@@ -100,20 +115,22 @@ fi
 ##############################################################################################
 # Command line processing
 ##############################################################################################
-while (($#)) && getopts 162mvifkzx:ht:n:d:b:s:t:a:p:e:j:l: opt "$@"
+while (($#)) && getopts 162wmvifkzx:hT:t:n:d:b:B:s:t:a:p:e:j:l:r:R: opt "$@"
 do
     case $opt in
         (n)     dvdname=$OPTARG;;
         (d)     dest=$OPTARG;;
-        (b)     target_bitrate=$OPTARG;;
+        (b)     target_video_bitrate=$OPTARG; custom_video_bitrate=1;;
+        (B)     target_audio_bitrate=$OPTARG; custom_audio_bitrate=1;;
        (s)     target_size=$OPTARG;;
-        (2)     audio_2ch=1;;
-        (6)     audio_6ch=1;;
+        (2)     audio_2ch=1; custom_audio_2ch=1;;
+        (6)     audio_6ch=1; custom_audio_6ch=1;;
         (1)     force_onepass_mode=1;;
         (v)     make_final_dest_vob=1;;
         (i)     make_final_dest_iso=1;;
         (f)     make_final_dest_folder=1;; 
         (z)     make_final_dest_comp=1;;
+       (R)     ripper=$OPTARG;;
        (e)     encoder=$OPTARG;;
         (m)     mirror_mode=1;;
         (k)     keep_intermediate_files=1;;
@@ -123,7 +140,9 @@ do
        (x)     extension=$OPTARG;;
        (j)     eject_disk=$OPTARG;;
        (l)     aid_override=$OPTARG;;
-        (w)     set -$opt;;
+       (r)     drc=$OPTARG;;
+        (w)     set -x;;
+       (T)     minimum_feature_title_length=$OPTARG;;
         (h)     show_usage=1;;
         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
@@ -143,18 +162,21 @@ function usage() {
     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
     echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
-    echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
+    echo >&2 "   -p <profile>  Specify which encoding profile to use in -w mode as shown below:"
     echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
-    echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
-    echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
+    echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding"
+    echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding (default)"
     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
     echo >&2 "                 Handbrake Only Encoder Profiles:"
+    echo >&2 "                 - mkvvhq = MKV, very high quality encoding, x264 codec, 2 pass encoding"
+    echo >&2 "                 - mkvhq = MKV, high quality encoding, x264 codec, 2 pass encoding"
+    echo >&2 "                 - mkv = MKV, high quality encoding, x264 codec, 2 pass encoding"
     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
-    echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile"
+    echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile (run HandBrakeCLI -z and replace spaces with underscores) "
     echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
@@ -163,12 +185,14 @@ function usage() {
     echo >&2 "   -v            Make the final image a DVD VOB file"
     echo >&2 "   -i            Make the final image a DVD ISO file"
     echo >&2 "   -f            Make the final image a DVD folder"
-    echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
+    echo >&2 "   -z            Make the final image a compressed fi[[ ! -e "$vobfile" ]]le based on your profile selection and encoder"
+    echo >&2 "   -R <ripper>   Specify the ripper to use to make the DVD image (valid rippers=ddrescue|makemkv|handbrake|mplayer) (default=makemkv if found)"
     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
-    echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
+    echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
-    echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
-    echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
+    echo >&2 "   -b <bitrate>  Set the video bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
+    echo >&2 "   -B <bitrate>  Set the audio bitrate desired in the compressed file in kbits/sec (ex: 96, 128, 160, 224 (default), 300, etc)"    
+    echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -z mode)"
     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
     echo >&2 "   -j <n>        Eject the disk:"
@@ -179,11 +203,14 @@ function usage() {
     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
     echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
+    echo >&2 "   -r <x.x>      Apply extra dynamic range compression to the audio, making soft sounds louder. "
+    echo >&2 "                 Range is 1.0 to 4.0 with 1.5 - 2.5 being a useful range (HandBrake Only) (default value is 0.0)"
     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
-    echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
+    echo >&2 "                 In -z mode, run with this option to keep the original .VOB file"
     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
+    echo >&2 "   -T <length>   Specify the minimum feature title length in minutes. This is used when picking which title to rip."
     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
     echo >&2 ""
     exit 2
@@ -200,41 +227,56 @@ if [ "$dest" == "" ]; then
   usage
 fi
 
-if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
-  echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
-  usage
+if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
+   [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
+    # Make our default dest type a compressed movie if the user didn't ask for anything else to be done
+    make_final_dest_comp=1
 fi
 
-if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
-  echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
+if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
+  echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-z' when using '-b' or '-s' or '-a'" | tee -a $logfile
   usage
 fi
 
-if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
-   [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
-  echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-z'" | tee -a $logfile
+if [ $target_video_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
+  echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-z'" | tee -a $logfile
   usage
 fi
 
 if [ $mirror_mode -eq 1 ]; then
   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
-    echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
+    echo "-E- You can't specify '-v' or '-i' or '-f' or '-z' when operating in mirror mode with '-m'" | tee -a $logfile
     usage
   fi
 fi
 
+# If audio channel requirements weren't given, assume a default value of 6channel audio
+if [ $audio_2ch -eq 0 ] && [ $audio_6ch -eq 0 ]; then
+  audio_6ch=1
+  custom_audio_6ch=1
+fi
+
+# Make makemkv the default ripper if not specified and we can find it
+if [ -z "$ripper" ]; then
+  ripper="makemkv"
+  [[ ! -x `which $makemkv` ]] && ripper="ddrescue";
+fi
+
 # Make handbrake the default encoder if not specified and we can find it
 if [ -z "$encoder" ]; then
   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
   [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
+  [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mkv" ]] && encoder="handbrake";
+  [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
 fi
 
 # Sanity check the profile selection
 if [[ "$encoder" == "mencoder" ]]; then
   [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
+  [[ "$profile" =~ "mkv" ]] && echo "-E- invalid encoder $encoder selected for mkv profile: $profile" && exit
 fi
 
 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
@@ -251,9 +293,15 @@ if [ "$aspect" != "" ]; then
   fi
   echo "$aspect" | grep -q ":"
   if [ $? != 0 ]; then
-    SCALE=",scale -zoom -sws 9 -xy $aspect"
+    [ "$encoder" == "mencoder" ] && SCALE=",scale -zoom -sws 9 -xy $aspect"
+    [ "$encoder" == "handbrake" ] && SCALE="-w $aspect"
   else
-    SCALE=",scale=$aspect"
+    [ "$encoder" == "mencoder" ] && SCALE=",scale=$aspect"
+    if [ "$encoder" == "handbrake" ]; then
+       WIDTH=`echo "$aspect" | awk -F ':' '{ print $1; }'`
+       HEIGHT=`echo "$aspect" | awk -F ':' '{ print $2; }'`
+       SCALE="-w $WIDTH -l $HEIGHT"
+    fi
   fi
 fi
 
@@ -266,9 +314,18 @@ fi
 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
-[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
-[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
-[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
+[[ -n "$handbrake_xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing handbrake xvid encoder, set in rip_dvd.conf to: $handbrake_xvid" && exit
+[[ -n "$handbrake_mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing handbrake mp4 encoder, set in rip_dvd.conf to: $handbrake_mp4" && exit
+[[ -n "$makemkv" ]] && [[ ! -x `which $makemkv` ]] && echo "-E- missing makemkv ripper, set in rip_dvd.conf to: $makemkv" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing HandBrake encoder: $handbrake_xvid" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing HandBrake encoder: $handbrake_mp4" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing HandBrake encoder: $handbrake_mp4" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing HandBrake encoder: $handbrake_mp4" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mkv" ]] && [[ ! -x `which $mkvextract` ]] && echo "-E- missing mkvextract: $mkvextract" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mkv" ]] && [[ ! -x `which $mkvpropedit` ]] && echo "-E- missing mkvpropedit: $mkvpropedit" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mkv" ]] && [[ ! -x `which $mkvmerge` ]] && echo "-E- missing mkvmerge: $mkvmerge" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $mp4box` ]] && echo "-E- missing mp4box: $mp4box" && exit
+[[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
 
 ##############################################################################################
 
@@ -281,9 +338,18 @@ if [ -z "$dvdname" ]; then
     echo "-E- Can't access the DVD device $dev"
     exit 1
   fi
+
   # now capture the volume name from the device
   dvdname=`volname $dev | awk '{ print $1 }'`
   ripdvd=1
+  # if the dvdname is still blank, go about it a different way (for BluRays)
+  if [[ -z "$dvdname" ]]; then
+    echo "-> Using makemkv to obtain disk label"
+    dvdname=`$makemkv info --noscan --robot disc:$makemkv_disc_id | grep "CINFO:2," | awk -F "," '{ print $3; }' | tr ' ' '_' | sed 's/\"//g'`
+    echo "   Found disk label: $dvdname"
+    ripdvd=1
+  fi
 
 else 
 
@@ -312,6 +378,7 @@ else
     file "$dvdname" | grep -q "MPEG"
     if [ $? == 0 ]; then
       # It is a valid MPEG2 file, now strip the extension off our dvdname
+      # An MPEG file is like a VOB file (intermediate format of the DVD movie)
       vobfile="$dvdname"
       dvdname=`basename "$dvdname"`
       dvdname=${dvdname%.[^.]*}
@@ -324,6 +391,8 @@ else
     file "$dvdname" | grep -q -e "ISO" -e "UDF"
     if [ $? == 0 ]; then
       # It is a valid ISO file, now strip the extension off our dvdname
+      # An ISO file is treated as a disc or DVD image that needs to be converted
+      # to an intermediate vobfile before it can be compressed.
       isofile="$dvdname"
       dvdname=`basename "$dvdname"`
       dvdname=${dvdname%.[^.]*}
@@ -331,11 +400,25 @@ else
       valid_file=1
     fi    
 
-    # check to see if dvdname is a full path to an ISO file
+    # check to see if dvdname is a full path to a VOB file
     # if it is, set dvdname and isofile appropriately
     file "$dvdname" | grep -q -e "VOB"
     if [ $? == 0 ]; then
       # It is a valid VOB file, now strip the extension off our dvdname
+      # A VOB file is an intermediate format of the DVD movie
+      vobfile="$dvdname"
+      dvdname=`basename "$dvdname"`
+      dvdname=${dvdname%.[^.]*}
+      keep_vobfile=1
+      valid_file=1
+    fi  
+    
+    # check to see if dvdname is a full path to an MKV file
+    # if it is, set dvdname and isofile appropriately
+    file "$dvdname" | grep -q -e "mkv"
+    if [ $? == 0 ]; then
+      # It is a valid MKV file, now strip the extension off our dvdname
+      # An MKV file is like a VOB file (intermediate format of the DVD movie)
       vobfile="$dvdname"
       dvdname=`basename "$dvdname"`
       dvdname=${dvdname%.[^.]*}
@@ -343,6 +426,7 @@ else
       valid_file=1
     fi    
 
+
     # If we didn't find a handler for the file above, complain
     if [ $valid_file -eq 0 ]; then
       echo "-E- Unsupported file type: $vobfile"
@@ -449,6 +533,153 @@ trap cleanup EXIT
 # processing functions
 ##############################################################################################
 
+function alarm() { perl -e 'alarm shift; exec @ARGV' "$@"; }
+
+function lsdvd_longest_title {
+  dev="$1"
+
+  # Only use lsdvd to extract the longest feature title if we didn't detect an incompatibility earlier
+  if [ $lsdvd_incompatibility -eq 1 ]; then
+    invalid_feature_title=1
+    return
+  fi
+
+  # Try the normal lsdvd command to see if it works
+  alarm $lsdvd_timeout lsdvd $dev >> "$logfile" 2>&1
+  if [ $? != 0 ]; then
+    # lsdvd didn't work
+    invalid_feature_title=1
+    lsdvd_incompatibility=1
+    return
+  fi
+  # lsdvd is good to go, use it
+  feature_title=`lsdvd $dev 2>/dev/null | awk '/Longest/ { print $NF }'`
+}
+
+function lsdvd_css {
+  dev="$1"
+
+  # Try the normal lsdvd command to see if it works
+  alarm $lsdvd_timeout lsdvd $dev >> "$logfile" 2>&1
+
+  if [ $? != 0 ]; then
+    # lsdvd didn't work. Try VLC.
+    lsdvd_incompatibility=1
+    if [[ -x `which cvlc` ]]; then 
+      echo "-> lsdvd failed to DeCSS the DVD. Trying VLC: $dev" | tee -a "$logfile"
+      alarm $lsdvd_timeout cvlc --no-video --no-audio $dev  >> "$logfile" 2>&1
+      # Once you get a DVD that VLC can't handle, figure out how 
+      # to detect that here and abort.
+      #if [ $? != 1 ]; then
+      #  echo "-> VLC failed to decss the DVD."
+      #  return 1
+      #fi
+    else
+      fatal_and_exit "-E- lsdvd failed to DeCSS the DVD. VLC not found, but required to rip this DVD."
+    fi
+  fi
+  return 0
+}
+
+# reduce the size of the mkv src file using handbrake
+function encode_mkv_file_makemkv {
+    src="$1"
+    dst="$2"
+    tmpdst=""
+
+    # Convert our ISO to a MKV if it is a real iso
+    if [[ $real_isofile -eq 1 ]]; then
+       tmpdst="$tmpdir/$dvdname.mkv"
+       make_dvd_mkv_image "$tmpdst" "iso" "$src"
+       src="$tmpdst"
+    fi
+
+    # Set a variable that we will use later to determine if we found a handler for $profile or not
+    typeset -i found_profile=0 
+  
+    # Globals
+    typeset quality=""
+    typeset handbrake_audio_opts=""
+    typeset handbrake_cli=""
+
+    # Predefined Handbrake Profile Handling
+    if [[ "$profile" =~ "mkvvhq" ]]; then
+       found_profile=1
+       handbrake_cli="$handbrake_mp4"
+       final_output_file="$dst"
+       quality="0.9"
+    fi
+    if [[ "$profile" =~ "mkvhq" ]]; then
+       found_profile=1
+       handbrake_cli="$handbrake_mp4"
+       final_output_file="$dst"
+       quality="0.85"
+    fi
+
+    # setup our audio option
+    if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
+       handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
+    fi
+    if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
+       handbrake_audio_opts="-E ac3 -6 auto"
+    fi
+    if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
+       handbrake_audio_opts="-E faac -6 dpl2"
+    fi
+
+    # find out what our audio track is
+    get_audio_track_from_mkv "$src" "$handbrake_cli"
+    if [ -n "$track" ]; then
+       handbrake_audio_opts="$handbrake_audio_opts -a $track"
+       track="" 
+    fi
+    
+    # Execute the handbrake command to encode the video
+    echo -e "\n   Encoding: $handbrake_cli -i \"$src\" -o \"$dst\" --strict-anamorphic --crop 0:0:0:0 -q $quality $handbrake_audio_opts -v 1 -m"
+    $handbrake_cli -i "$src" -o "$dst" --strict-anamorphic --crop 0:0:0:0 -q $quality $handbrake_audio_opts -v 1 | tee -a $encodelog 2>&1
+    handbrake_retval=$?
+
+    if [ $handbrake_retval != 0 ]; then
+       fatal_and_exit "-E- Unhandled handbrake error"
+    fi
+
+    # Extract the chapters from the src and apply to the dst
+    chapter_tmpfile="$tmpdir/$dvdname.xml"
+    $mkvextract chapters "$src" > "$chapter_tmpfile"
+    $mkvpropedit -c "$chapter_tmpfile" "$dst"
+
+    # find out what our default_alang subtitle track is in the src
+    get_subtitle_track_from_mkv "$src" "$handbrake_cli"
+
+    # Extract the subtitles from the src and apply to the dst
+    srt_tmpfile="$tmpdir/$dvdname.srt"
+    sub_tmpfile="$tmpdir/$dvdname.sub"
+    idx_tmpfile="$tmpdir/$dvdname.idx"
+    $mkvextract tracks "$src" $track:$srt_tmpfile
+    $mkvmerge -o "$dst.subs" "$dst" $idx_tmpfile
+    mv "$dst.subs" "$dst"
+
+    # Set the default subtitle track to "no subtitles" in the dst
+    $mkvpropedit "$dst" --edit track:s1 --set flag-default=0
+
+    # Concatenate the encode log to our main log file, greping out unwanted lines
+    cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
+    cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
+    cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"  
+
+    # Remove intermediary file if we created one   
+    if [ $keep_intermediate_files -eq 0 ]; then
+       [[ -e "$tmpdst" ]] && rm -f "$tmpdst"
+       rm "$chapter_tmpfile"
+       rm "$idx_tmpfile" "$sub_tmpfile"
+    else
+       echo "-> Keeping intermediate chapter file: $chapter_tmpfile" | tee -a "$logfile"
+       echo "-> Keeping intermediate subtitle files: $idx_tmpfile $sub_tmpfile" | tee -a "$logfile"
+       [[ -e "$tmpdst" ]] && echo "-> Keeping intermediate MKV file: $tmpdst" | tee -a "$logfile"
+    fi
+}
+
 # encode the vob file into a compressed file format using handbrake
 function encode_vob_file_handbrake {
   
@@ -457,21 +688,41 @@ function encode_vob_file_handbrake {
   typeset handbrake_video_encoder_opts=""
   typeset filetype=""
   typeset handbrake_audio_opts=""
+  typeset hb_profile=""
+  typeset SIZE=""
+  typeset AUDIO_BITRATE=""
 
   # Set a variable that we will use later to determine if we found a handler for $profile or not
   typeset -i found_profile=0    
 
-  # For a given profile, to override the 2 pass behavior to be single pass,
-  # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
-  # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
+  # Default is 2 pass mode. Profiles can override this. Command line can override this as well.
   PASSES="-2"
+  if [ $force_onepass_mode -eq 1 ]; then
+      PASSES=""
+  fi
+
+  # Set our DRC option
+  DRC="-D $drc"
+
+  if [ $target_size -ne 0 ]; then
+    SIZE="-S $target_size"
+  fi 
+
+  if [ $custom_audio_bitrate -eq 1 ]; then
+    AUDIO_BITRATE="-B $target_audio_bitrate"
+  fi
 
-  # Check the global force_onepass_mode. If it is set, change our variables appropriately
-  # to force 1-pass encoding across all profiles.
   if [ $force_onepass_mode -eq 1 ]; then
     PASSES=""
   fi
 
+  # get our audio track from the vobfile (requires mp4 version of handbrake to extract)
+  if [[ "$vobfile" =~ /mkv/ ]]; then
+      get_subtitle_track_from_mkv "$vobfile" "$handbrake_mp4"
+  else
+      get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
+  fi
+
   # XVID profile
   if [[ "$profile" =~ "xvid" ]]; then
     found_profile=1
@@ -482,8 +733,8 @@ function encode_vob_file_handbrake {
     # Very High Quality (16fps)
     if [ "$profile" == "xvidvhq" ]; then
       handbrake_opts[0]="-f avi"
-      handbrake_opts[1]="-b $target_bitrate"
-      handbrake_opts[2]="-e ffmpeg"
+      handbrake_opts[1]="-b $target_video_bitrate"
+      handbrake_opts[2]="-e xvid"
       handbrake_opts[3]="-T"
       handbrake_opts[4]="-5"
       handbrake_opts[5]="-8"
@@ -491,7 +742,7 @@ function encode_vob_file_handbrake {
     # High Quality (20fps)
     if [ "$profile" == "xvidhq" ]; then
       handbrake_opts[0]="-f avi"
-      handbrake_opts[1]="-b $target_bitrate"
+      handbrake_opts[1]="-b $target_video_bitrate"
       handbrake_opts[2]="-e ffmpeg"
       handbrake_opts[3]="-T"
       handbrake_opts[4]="-5"
@@ -499,18 +750,30 @@ function encode_vob_file_handbrake {
     # Fast (28fps)
     if [ "$profile" == "xvid" ]; then
       handbrake_opts[0]="-f avi"
-      handbrake_opts[1]="-b $target_bitrate"
+      handbrake_opts[1]="-b $target_video_bitrate"
       handbrake_opts[2]="-e ffmpeg"
       handbrake_opts[3]="-T"
     fi
   fi
 
-  # MP4 profile
-  if [[ "$profile" =~ "mp4" ]]; then
+  # MP4 || MKV profile
+  if [[ "$profile" =~ "mp4" ]] || [[ "$profile" =~ "mkv" ]]; then
     found_profile=1
     handbrake_cli="$handbrake_mp4"
-    final_output_file="$dest/$dvdname.mp4"
-    PASSES=""
+    [[ "$profile" =~ "mp4" ]] && final_output_file="$dest/$dvdname.mp4"
+    [[ "$profile" =~ "mkv" ]] && final_output_file="$dest/$dvdname.mkv"        
+    PASSES="$PASSES -T"
+
+    # Handle custom parameter overrides
+    if [ $custom_video_bitrate == 1 ]; then
+      handbrake_opts[0]="-b $target_video_bitrate"
+    fi
+    if [ $custom_audio_2ch == 0 ]; then
+      audio_2ch=0
+    fi
+    if [ $custom_audio_6ch == 0 ]; then
+      audio_6ch=0
+    fi
 
     # Very High Quality
     if [ "$profile" == "mp4vhq" ]; then
@@ -533,14 +796,26 @@ function encode_vob_file_handbrake {
     final_output_file="$dest/$dvdname.mp4"
     PASSES=""
 
+    # Handle custom parameter overrides
+    if [ $custom_video_bitrate == 1 ]; then
+      handbrake_opts[0]="-b $target_video_bitrate"
+    fi
+    if [ $custom_audio_2ch == 0 ]; then
+      audio_2ch=0
+    fi
+    if [ $custom_audio_6ch == 0 ]; then
+      audio_6ch=0
+    fi
+
     # iphone
     if [ "$profile" == "iphone" ]; then
-      profile="hb_iPhone"
+      profile="hb_iPhone_&_iPod_Touch"
     fi
     # ipod
     if [ "$profile" == "ipod" ]; then
       profile="hb_iPod"
     fi
+
   fi
   
   # Predefined Handbrake Profile Handling
@@ -548,11 +823,20 @@ function encode_vob_file_handbrake {
     found_profile=1
     handbrake_cli="$handbrake_mp4"
     final_output_file="$dest/$dvdname.mp4"
-    PASSES=""
+
+    # Handle custom parameter overrides
+    if [ $custom_video_bitrate == 1 ]; then
+      handbrake_opts[0]="-b $target_video_bitrate"
+    fi
+    if [ $custom_audio_2ch == 0 ]; then
+      audio_2ch=0
+    fi
+    if [ $custom_audio_6ch == 0 ]; then
+      audio_6ch=0
+    fi
     
     # extract the HandBrake Profile name from $profile
     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
-    handbrake_opts[0]="-Z \"$hb_profile\""
   fi
 
   # Make sure we found a handler for the given profile
@@ -562,14 +846,17 @@ function encode_vob_file_handbrake {
 
   # setup our audio option
   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
-    handbrake_audio_opts="-E faac,ac3 -6 dpl2,6ch"
+    handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
   fi
-  if [ $audio_6ch -eq 1 ]; then
-    handbrake_audio_opts="-E ac3 -6 6ch"
+  if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
+    handbrake_audio_opts="-E ac3 -6 auto"
   fi
-  if [ $audio_2ch -eq 1 ]; then
+  if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
     handbrake_audio_opts="-E faac -6 dpl2"
   fi
+  if [ -n "$track" ]; then
+    handbrake_audio_opts="$handbrake_audio_opts -a $track"
+  fi
 
   # Convert our array of opts into a string
   for OPTS in "${video_encoder_opts[@]}"; do 
@@ -581,17 +868,96 @@ function encode_vob_file_handbrake {
   for OPTS in "${handbrake_opts[@]}"; do 
     handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
   done
-  
+
+  # Append "global" command line options
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts -v 1 -m"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $PASSES"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $DRC"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SCALE"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SIZE"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $AUDIO_BITRATE"
+
   # Execute the handbrake command to encode the video
-  echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1" >> "$logfile"
-  $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1
-  handbrake_retval=$?
+  # I have to copy-n-paste the code below to handle the 2 conditions, 1) hb_profile (mp4) 2) no hb_profile (xvid)
+  # The problem is the -Z "$hb_profile" option. I have to quote the "$hb_profile" due to spaces in it, forcing me to call it out explicity.
+  if [ -n "$hb_profile" ]; then
+    echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
+    $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
+    handbrake_retval=$?
+  else 
+    echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
+    $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
+    handbrake_retval=$?
+  fi
   if [ $handbrake_retval != 0 ]; then
     fatal_and_exit "-E- Unhandled handbrake error"
   fi
 
+  
+  # SRC = ISO and FINAL = MP4
+  # Extract the chapters from the ISO/VOB so we can add them to the MP4 file. 
+  # We can only do this if we have an ISO file and we made an MP4 file.
+  if [[ "$final_output_file" =~ "mp4" ]] && [[ -e "$isofile" ]]; then
+    chapter_tmpfile="$tmpdir/$dvdname.chapters"
+    $dvdxchap -t $feature_title "$isofile" > "$chapter_tmpfile"
+    $mp4box -chap "$chapter_tmpfile" "$final_output_file"
+
+    # We could also add subtitles, but we would need to follow this guide to do it:
+    # http://ubuntuforums.org/showthread.php?t=1253635
+    # http://en.gentoo-wiki.com/wiki/Ripping_DVD_to_Matroska_and_H.264
+
+  fi
+
+  # SRC = ISO and FINAL = MKV
+  if [[ "$final_output_file" =~ "mkv" ]] && [[ -e "$isofile" ]]; then
+    chapter_tmpfile="$tmpdir/$dvdname.chapters"
+    $dvdxchap -t $feature_title "$isofile" > "$chapter_tmpfile"
+    $mkvpropedit -c "$chapter_tmpfile" "$final_output_file"
+  fi
+
+  # SRC = MKV and FINAL = MP4
+  if [[ "$final_output_file" =~ "mp4" ]] && [[ "$vobfile" =~ "mkv" ]]; then
+    # Extract the chapters from the src and apply to the dst
+    chapter_tmpfile="$tmpdir/$dvdname.xml"
+    $mkvextract chapters "$vobfile" > "$chapter_tmpfile"
+    $mp4box -chap "$chapter_tmpfile" "$final_output_file"
+  fi
+
+  # SRC = MKV and FINAL = MKV
+  # If our original src file was an MKV, extract the chapters and subtitles from it
+  if [[ "$final_output_file" =~ "mkv" ]] && [[ "$vobfile" =~ "mkv" ]]; then
+    # Extract the chapters from the src and apply to the dst
+    chapter_tmpfile="$tmpdir/$dvdname.xml"
+    $mkvextract chapters "$vobfile" > "$chapter_tmpfile"
+    $mkvpropedit -c "$chapter_tmpfile" "$final_output_file"
+
+    # find out what our default_alang subtitle track is in the src
+    get_subtitle_track_from_mkv "$vobfile" "$handbrake_mp4"
+
+    # Extract the subtitles from the src and apply to the dst
+    srt_tmpfile="$tmpdir/$dvdname.srt"
+    sub_tmpfile="$tmpdir/$dvdname.sub"
+    idx_tmpfile="$tmpdir/$dvdname.idx"
+    $mkvextract tracks "$vobfile" $track:$srt_tmpfile
+    $mkvmerge -o "$final_output_file.subs" "$final_output_file" "$idx_tmpfile"
+    mv "$final_output_file.subs" "$final_output_file"
+
+    # Set the default subtitle track to "no subtitles" in the dst
+    $mkvpropedit "$final_output_file" --edit track:s1 --set flag-default=0 
+  fi
+
+  # Remove intermediary file if we created one   
+  if [ $keep_intermediate_files -eq 0 ]; then
+      [[ -e "$chapter_tmpfile" ]] && rm "$chapter_tmpfile"
+      [[ -e "$idx_tmpfile" ]] && rm "$idx_tmpfile" 
+      [[ -e "$sub_tmpfile" ]] && rm "$sub_tmpfile"
+  else
+      [[ -e "$chapter_tmpfile" ]] && echo "-> Keeping intermediate chapter file: $chapter_tmpfile" | tee -a "$logfile"
+      [[ -e "$idx_tmpfile" ]] && echo "-> Keeping intermediate subtitle files: $idx_tmpfile $sub_tmpfile" | tee -a "$logfile"
+  fi
+
   # Concatenate the encode log to our main log file, greping out unwanted lines
-  cat $encodelog | grep -v "Encoding" >> "$logfile" 
+  cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
 }
@@ -630,7 +996,7 @@ function encode_vob_file_mencoder {
 
     # Very High Quality (16fps)
     if [ "$profile" == "xvidvhq" ]; then
-      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[0]="bitrate=$target_video_bitrate"
       video_encoder_opts[1]="threads=$mencoder_threads"
       video_encoder_opts[2]="chroma_opt"
       video_encoder_opts[3]="vhq=4"
@@ -640,7 +1006,7 @@ function encode_vob_file_mencoder {
     fi
     # High Quality (20fps)
     if [ "$profile" == "xvidhq" ]; then
-      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[0]="bitrate=$target_video_bitrate"
       video_encoder_opts[1]="threads=$mencoder_threads"
       video_encoder_opts[2]="chroma_opt"
       video_encoder_opts[3]="vhq=2"
@@ -650,7 +1016,7 @@ function encode_vob_file_mencoder {
     fi
     # Fast (28fps)
     if [ "$profile" == "xvid" ]; then
-      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[0]="bitrate=$target_video_bitrate"
       video_encoder_opts[1]="threads=$mencoder_threads"
       video_encoder_opts[2]="vhq=0"
       video_encoder_opts[3]="turbo"
@@ -670,7 +1036,7 @@ function encode_vob_file_mencoder {
       mencoder_audioch_opts[2]=""
     else
       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
-      mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
+      mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$target_audio_bitrate"
       mencoder_audioch_opts[0]=""
     fi
  
@@ -697,7 +1063,7 @@ function encode_vob_file_mencoder {
     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
-    video_encoder_opts[0]="bitrate=$target_bitrate"
+    video_encoder_opts[0]="bitrate=$target_video_bitrate"
     video_encoder_opts[1]="threads=$mencoder_threads"
     video_encoder_opts[2]="vbv_maxrate=1500"
     video_encoder_opts[3]="vbv_bufsize=2000"
@@ -714,7 +1080,7 @@ function encode_vob_file_mencoder {
       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
     done
 
-    mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
+    mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$target_audio_bitrate:raw"
     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
   fi
 
@@ -759,6 +1125,69 @@ function encode_vob_file_mencoder {
   done
 }
 
+function make_dvd_mkv_image {
+    dstmkv="$1"
+    srctype="$2"
+    srcname="$3"
+    dstdir=${dstmkv%.[^.]*}
+    ((min_length = minimum_feature_title_length * 60))
+
+    echo -e "\n   Ripping: $makemkv mkv --minlength=$min_length --decrypt --progress=-same $srctype:$srcname all $dstdir"
+    mkdir -p "$dstdir"
+    $makemkv mkv --minlength=$min_length --decrypt --progress=-same $srctype:$srcname all $dstdir 2>&1 | tee -a "$ddrescuelog"
+    makemkv_retval=$?
+    
+    if [ $makemkv_retval != 0 ]; then
+       fatal_and_exit "-E- Unhandled makemkv error"
+    fi
+
+    if [ $makemkv_copy_largest_title_only -eq 1 ]; then
+      # Move the largest created MKV file to destination
+      # There might be multiple ones, so just grab the largest one
+      largest_mkv_file=`/bin/ls -1S "$dstdir"/*.mkv | head -1`
+      echo -e "\n   Moving largest mkv file $largest_mkv_file -> $dstmkv\n" | tee -a "$ddrescuelog"
+      mv "$largest_mkv_file" "$dstmkv"
+    else
+      # Move all of the created MKV files to destination
+      echo "\n" | tee -a "$ddrescuelog"
+      dstfile=${dstmkv%.[^.]*}
+      typeset -i num=0
+      typeset -i titles=0
+      for i in `/bin/ls -1 "$dstdir"/*.mkv`; do
+       ((titles = titles + 1))
+      done
+      if [[ $titles > 1 ]]; then
+        for i in `/bin/ls -1 "$dstdir"/*.mkv`; do
+          echo -e "   Moving $i -> $dstfile.$num.mkv" | tee -a "$ddrescuelog"
+          mv "$i" "$dstfile.$num.mkv"
+          ((num = num + 1 ))
+        done
+      else 
+         echo -e "  Moving $dstdir/*.mkv -> $dstfile.mkv" | tee -a "$ddrescuelog"
+         mv "$dstdir"/*.mkv "$dstfile.mkv"
+      fi
+      echo "\n" | tee -a "$ddrescuelog"
+    fi
+
+    if [ $? != 0 ]; then
+       fatal_and_exit "-E- Unhandled mv error"
+    fi
+    if [ $keep_intermediate_files -eq 0 ]; then
+       [[ -d "$dstdir" ]] && rm -rf "$dstdir"
+    fi
+
+    # Concatenate the encode log to our main log file, greping out unwanted lines
+    cat "$ddrescuelog" | grep -v "Current progress:" >> "$logfile"    
+}
+
+function make_dvd_mkv_image_from_folder {
+    src="$1"
+    dst="$2"
+    handle_error=$3
+    dstdir=${dst%.[^.]*}
+    make_dvd_mkv_image "$dst" "file" "$src"
+}
+
 function make_dvd_iso_image {
 
   isofile="$1"
@@ -766,7 +1195,7 @@ function make_dvd_iso_image {
   # check to see if we have a dvdpath to rip from instead of $dev
   if [ -z "$dvdpath" ]; then
     # load the CSS codes in the DVD drive 
-    lsdvd $dev >> "$logfile"
+    lsdvd_css "$dev"
     if [ $? != 0 ]; then
       fatal_and_exit "-E- lsdvd $dev failed" 
     fi
@@ -867,9 +1296,9 @@ function get_feature_title {
   fi
   # otherwise, use lsdvd to figure it out
   if [ $ripdvd -eq 1 ]; then
-    feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
+    lsdvd_longest_title "$dev" 
   else 
-    feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
+    lsdvd_longest_title "$source"
   fi
 }
 
@@ -902,7 +1331,7 @@ function create_main_vob_with_mplayer {
   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
-    msg="$msg We also detected another condition that requires us to use dumpstream. "
+    msg="$msg We also detected a condition that may require you to use dumpstream. "
     msg="$msg\n    Unable to rip this DVD in the mode you requested."
     fatal_and_exit "$msg"
   fi
@@ -992,6 +1421,87 @@ function get_crop_from_vob {
   echo "   Setting mencoder crop filter to: $CROP"
 }
 
+function get_audio_track_from_mkv { 
+  mkv="$1"
+  handbrake_cli="$2"
+  aidcheck=`tempfile`
+  alang=$default_alang
+
+  # Find out what audio track matches our alang
+  $handbrake_cli --stop-at duration:1 -i "$mkv" -o /dev/null -v 100 > $aidcheck 2>&1
+  stream=`grep "$alang" $aidcheck | grep "Audio:"`
+
+  # extract the track number that handbrake uses
+  track=`echo "$stream" | awk '{ print $2; }' | awk -F '.' '{ print $2; }' | awk -F '(' '{ print $1; }'`
+  
+  if [ -n "$track" ]; then   
+      echo "   Setting the audio track to $track." | tee -a "$logfile"
+  fi
+}
+
+function get_subtitle_track_from_mkv { 
+  mkv="$1"
+  handbrake_cli="$2"
+  aidcheck=`tempfile`
+  alang=$default_alang
+
+  # Find out what audio track matches our alang
+  $handbrake_cli --stop-at duration:1 -i "$mkv" -o /dev/null -v 100 > $aidcheck 2>&1
+  stream=`grep "$alang" $aidcheck | grep "Subtitle:" | head -n 1`
+
+  # extract the track number that handbrake uses
+  track=`echo "$stream" | awk '{ print $2; }' | awk -F '.' '{ print $2; }' | awk -F '(' '{ print $1; }'`
+
+  # add 1 to the track number since mkv tools start at 1, and HandBrake starts at 0
+  ((track = track + 1))
+
+  if [ -n "$track" ]; then   
+      echo "   Setting the subtitle track to $track." | tee -a "$logfile"
+  fi
+}
+
+function get_audio_track_from_vob {
+  # Adjust our audio ID to find the english audio stream
+  # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
+  vob="$1"
+  handbrake_cli="$2"
+  aidcheck=`tempfile`
+  aid=$default_aid
+  alang=$default_alang
+  if [ $aid_override -lt 0 ]; then 
+    mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
+    grep -q "Found audio stream: $aid" $aidcheck
+    while [ $? == 1 ] && [ $aid -lt 159 ]; do
+      (( aid = aid + 1 ))
+      grep -q "Found audio stream: $aid" $aidcheck
+    done
+    [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+  else 
+    aid=$aid_override
+  fi
+  # Now that we've found the right audio id, find the corresponding audio track in HandBrake
+
+  # convert the aid we found into hex
+  aid_hex=`echo "obase=16; $aid" | bc`
+  
+  # extract the audio streams in the vob
+  #ffmpeg -i "$vob" > $aidcheck 2>&1
+  $handbrake_cli --stop-at duration:1 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
+  
+  # find the stream that matches our aid
+  #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
+  #stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
+  stream=`grep "add_audio_to_title:" $aidcheck | grep -n "" | grep "add_audio_to_title:.* stream 0x$aid_hex"`
+  # extract the track number that handbrake uses
+  #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
+  track=`expr match "$stream" '^\([0-9]*\):'`
+
+  if [ -n "$track" ]; then   
+    echo "   Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
+  fi
+}
+
 function get_audio_id_from_vob {
   # Adjust our audio ID to find the english audio stream
   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
@@ -1122,10 +1632,23 @@ function check_vob_for_a52_crc_errors {
 
 function calculate_bitrate_from_target_size {
   # determine what our bitrate needs to be if a target size was specified instead
-  if [ $target_size -ne 0 ]; then
+  if [ $target_size -ne 0 ] && [ $custom_video_bitrate -eq 0 ]; then
     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
-    ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
-    echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
+    ((min_length = minimum_feature_title_length * 60))
+    if [[ $vob_length -gt $min_length ]]; then 
+      ((target_video_bitrate = (target_size * 1024 * 8) / vob_length ))
+      custom_video_bitrate=1
+      echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_video_bitrate kbits/sec" | tee -a "$logfile"
+    else
+      echo "-W- Unable to determine the real length of this DVD feature title." | tee -a "$logfile"
+      echo "    A target bitrate from the target_size requested will not be set." | tee -a "$logfile"
+      echo "    If using handbrake, only the target_size will be passed to the encoder." | tee -a "$logfile" 
+      echo "    If using mencoder, the target_size will be entirely disregarded." | tee -a "$logfile"
+      echo "    You may need to rerun with the -b option with a target bitrate to get the desired size." | tee -a "$logfile"
+      if [[ $encoder -ne "handbrake" ]] || [[ "$profile" =~ "xvid" ]]; then
+        fatal_and_exit "-E- You'll need rip this DVD with the handbrake encoder and an MP4 type profile to get a good rip."
+      fi
+    fi
   fi
 }
 
@@ -1183,6 +1706,15 @@ function check_for_mplayer_dumpstream_incompatibility {
 
   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
 
+  # Check to see if the DVD had any lsdvd incompatibilities
+  if [ $lsdvd_incompatibility -eq 1 ]; then
+    invalid_feature_title=1
+    echo "-E- Unable to determine the feature title due to an lsdvd inability to DeCSS" | tee -a "$logfile"
+    echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
+    echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"    
+    return
+  fi
+
   if [ ! -e "$vobfile" ]; then
     # mplayer dumpstream does not work on DVDs that obscure the feature title.
     # A DVD that has 99 titles, where the longest title isn't the main feature
@@ -1190,9 +1722,9 @@ function check_for_mplayer_dumpstream_incompatibility {
     # out what the feature title is. This script will run through that flow if we
     # set use_mplayer_dumpstream to 0. Check for this here.
     if [ $ripdvd -eq 1 ]; then
-      lsdvd $dev | grep -q "Title: 99"
+      alarm $lsdvd_timeout lsdvd $dev | grep -q "Title: 99"
     else
-      lsdvd "$isofile" | grep -q "Title: 99"
+      alarm $lsdvd_timeout lsdvd "$isofile" | grep -q "Title: 99"
     fi
     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
@@ -1227,6 +1759,23 @@ function check_for_mplayer_dumpstream_incompatibility {
     fi
     [[ -e "$dumplog" ]] && rm -f $dumplog
   fi
+
+  # There is another form of protection that causes the mplayer dumpstream to fail.
+  # The resulting VOB file looks complete, but has something in it that causes mplayer/mencoder 
+  # to be unable to encode it since it thinks the entire VOB is only a few minutes long in length.
+  # Using HandBrake with an MP4 type profile can work around this, but mencoder or Handbrake with XVID profile won't.
+  if [ -e "$vobfile" ]; then
+    vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
+    ((min_length = minimum_feature_title_length * 60))
+    if [[ $vob_length -lt $min_length ]]; then 
+      if [[ $encoder -ne "handbrake" ]] || [[ "$profile" =~ "xvid" ]]; then
+        echo "-E- The main feature title that was ripped from the DVD has an invalid movie length." | tee -a "$logfile"
+        echo "    You'll need rip this DVD with the handbrake encoder and an MP4 or MKV type profile instead." | tee -a "$logfile"
+        mplayer_dumpstream_incompatibility=1
+       fatal_and_exit "-E- Aborting encoding step due to invalid movie length."
+      fi
+    fi
+  fi
 }
 
 function fill_mythvideo_metadata {
@@ -1293,15 +1842,38 @@ echo "$cmd" >> "$logfile"
 if [ $mirror_mode -eq 1 ]; then
   echo "-> Ripping DVD $dvdname to $dest"
 
-  # use ddrescue to make an ISO image of the disk
-  make_dvd_iso_image "$dest/$dvdname.iso"
-
-  # add this video data to the mythtv DB
-  fill_mythvideo_metadata "$dest/$dvdname.iso" 
+  if [[ "$ripper" == "makemkv" ]]; then
+      # use makemkv to make an MKV file of the disk
+      make_dvd_mkv_image "$tmpdir/$dvdname.mkv" "disc" "$makemkv_disc_id"
+      # move the ripped movies into place
+      typeset -i num=0 
+      for i in `/bin/ls -1 "$tmpdir/$dvdname"*.mkv`; do
+        if [[ "$i" =~ .[[:digit:]].mkv ]]; then
+          finaldest="$dest/$dvdname.$num.mkv"
+        else
+          finaldest="$dest/$dvdname.mkv"
+        fi
+        while [[ -e "$finaldest" ]]; do
+          ((num = num + 1 ))
+          finaldest="$dest/$dvdname.$num.mkv"
+        done
+        echo "   Moving $i -> $finaldest"
+        mv "$i" "$finaldest"
+      done
+      # add this video data to the mythtv DB
+      fill_mythvideo_metadata "$dest_filename"
+  else       
+      # use ddrescue to make an ISO image of the disk
+      make_dvd_iso_image "$tmpdir/$dvdname.iso"
+      echo "   Moving $tmpdir/$dvdname.iso -> $dest/$dvdname.iso"
+      mv "$tmpdir/$dvdname.iso" "$dest/$dvdname.iso"
+      # add this video data to the mythtv DB
+      fill_mythvideo_metadata "$dest_filename"
+  fi
 
   # eject the disk upon completion
   if [ $eject_disk -ne 0 ]; then
-    eject -T $dev
+    eject $eject_opts $dev
   fi
 
   date=`date`
@@ -1319,29 +1891,42 @@ if [ $mirror_mode -eq 0 ]; then
   # Rip image from DVD
   if [ $ripdvd -eq 1 ]; then
     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
-    # use ddrescue to make an ISO image of the disk
-    make_dvd_iso_image "$tmpdir/$dvdname.iso"
+    if [[ "$ripper" == "makemkv" ]]; then
+       # use makemkv to make an MKV file of the disk
+       make_dvd_mkv_image "$tmpdir/$dvdname.mkv" "disc" "$makemkv_disc_id"
+       vobfile="$tmpdir/$dvdname.mkv"
+    else 
+        # use ddrescue to make an ISO image of the disk
+       make_dvd_iso_image "$tmpdir/$dvdname.iso"
+       isofile="$tmpdir/$dvdname.iso"
+    fi
   fi
 
   # Rip image from DVD path
   if [ -n "$dvdpath" ]; then
     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
-    make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
-  fi
-
-  # make sure our isofile value is set
-  if [ -z "$isofile" ]; then
+    make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1  
     isofile="$tmpdir/$dvdname.iso"
   fi
-     
   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
 
-    if [ ! -e "$vobfile" ]; then
-      echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
-      
-      # get the feature title from the ISO
-      get_feature_title "$isofile"
+    # Create our "vobfile" using makemkv if told to do so
+    if [[ "$isofile" =~ "iso" ]] && [[ "$ripper" == "makemkv" ]]; then
+       echo "-> Creating VOB/MKV file from $isofile"
+       vobfile="$tmpdir/$dvdname.mkv"
+       make_dvd_mkv_image "$vobfile" "iso" "$isofile"
+    fi
+
+    # get the feature title from the ISO
+    if [[ "$isofile" =~ "iso" ]]; then
+       get_feature_title "$isofile"
+    fi
+
+    # Create our "vobfile" using mplayer if needed
+    if [[ ! -e "$vobfile" ]] && [[ "$isofile" =~ "iso" ]]; then
+      echo "-> Creating DVD video $vobfile from $isofile" | tee -a "$logfile"
+       
       # get the crop value from the ISO
       get_crop_from_iso
 
@@ -1398,7 +1983,7 @@ if [ $mirror_mode -eq 0 ]; then
       remove_intermediate_iso_file
 
     else
-      if [ "$encoder" != "handbrake" ]; then 
+      if [[ -e "$vobfile" ]] && [[ "$encoder" != "handbrake" ]]; then 
         echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
         # get our audio id from the VOB file
         get_audio_id_from_vob "$vobfile"
@@ -1408,7 +1993,7 @@ if [ $mirror_mode -eq 0 ]; then
     fi
 
     # eject the DVD disk since we are finished with it
-    [ $eject_disk -eq 2 ] && eject -T $dev
+    [ $eject_disk -eq 2 ] && eject $eject_opts $dev
 
     # encode the VOB file to a compressed file format
     if [ $make_final_dest_comp -eq 1 ]; then
@@ -1494,7 +2079,7 @@ if [ $mirror_mode -eq 0 ]; then
   remove_intermediate_dvdbackup_folder
 
   # eject the DVD disk upon completion
-  [ $eject_disk -eq 1 ] && eject -T $dev
+  [ $eject_disk -eq 1 ] && eject $eject_opts $dev
 
   date=`date`
   echo "$date DVD rip completed" | tee -a "$logfile"